////////////////////////////////////		
//MADE BY A SIMPLE VIRTUAL SAILOR //
////////////////////////////////////

object OfficerTypes;

void InitOfficerTypes()
{
	/* check for being companion / main character instead
	//Captain - all skill, all perks, for the moment.
	officer.name = "Captain";
	officer.skills.Leadership = 2;
	officer.skills.Fencing = 2;
	officer.skills.Sailing = 2;
	officer.skills.Accuracy = 2;
	officer.skills.Cannons = 2;
	officer.skills.Grappling = 2;
	officer.skills.Repair = 2;
	officer.skills.Defence = 2;
	officer.skills.Commerce = 2;
	officer.skills.Sneak = 2;

	officer.perks.BasicDefence = 1;
	officer.perks.AdvancedDefence = 1;
	officer.perks.Toughness = 1;
	officer.perks.CriticalHit = 1;
	officer.perks.SwordplayProfessional = 1;
	officer.perks.Rush = 1;
	officer.perks.Gunman = 1;
	officer.perks.GunProfessional = 1;
	officer.perks.IronWill = 1;
	officer.perks.SharedExperience = 1;
	officer.perks.BasicLandOwner = 1;
	officer.perks.FastReload = 1;
	officer.perks.ImmediateReload = 1;
	officer.perks.HullDamageUp = 1;
	officer.perks.SailsDamageUp = 1;
	officer.perks.CrewDamageUp = 1;
	officer.perks.CriticalShoot = 1;
	officer.perks.LongRangeShoot = 1;
	officer.perks.CannonProfessional = 1;
	officer.perks.LongRangeGrappling = 1;
	officer.perks.GrapplingProfessional = 1;
	officer.perks.InstantBoarding = 1;
	officer.perks.MusketsShoot = 1;
	officer.perks.BasicBattleState = 1;
	officer.perks.AdvancedBattleState = 1;
	officer.perks.ShipDefenceProfessional = 1;
	officer.perks.LightRepair = 1;
	officer.perks.InstantRepair = 1;
	officer.perks.ShipSpeedUp = 1;
	officer.perks.ShipTurnRateUp = 1;
	officer.perks.StormProfessional = 1;
	officer.perks.Turn180 = 1;
	officer.perks.SandbankManeuver = 1;
	officer.perks.SailingProfessional = 1;
	officer.perks.BasicCommerce = 1;
	officer.perks.AdvancedCommerce = 1;
	officer.perks.Trustworthy = 1;
	officer.perks.Brander = 1;
	officer.perks.Troopers = 1;
	*/

	//First Mate
	string type = OFFIC_TYPE_FIRSTMATE;
	OfficerTypes.(type).skills.Leadership = 2;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 1;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;

	// TODO: keep IronWill or not?
	// seems to be personal skill...
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.(type).perks.Brander = 1};
	if(isPerkExisting("Troopers")) {OfficerTypes.(type).perks.Troopers = 1};

	//Quarter Master - Master Purser in fact.
	type = OFFIC_TYPE_QMASTER;
	OfficerTypes.(type).skills.Leadership = 1;			// set from 0 to 1 by El Rapido
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 1;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 2;
	OfficerTypes.(type).skills.Sneak = 0;

	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("BasicLandOwner")) {OfficerTypes.(type).perks.BasicLandOwner = 1};

	//Doctor
	type = OFFIC_TYPE_DOCTOR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 2;
	OfficerTypes.(type).skills.Commerce = 1;
	OfficerTypes.(type).skills.Sneak = 1;			// set from 0 to 1 by El Rapido

	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("ShipDefenceProfessional")) {OfficerTypes.(type).perks.ShipDefenceProfessional = 1};
	
	//Cannoneer
	type = OFFIC_TYPE_CANNONEER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 2;
	OfficerTypes.(type).skills.Cannons = 2;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;

	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("ImmediateReload")) {OfficerTypes.(type).perks.ImmediateReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.(type).perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("CannonProfessional")) {OfficerTypes.(type).perks.CannonProfessional = 1};

	//Navigator - what is he supposed to do, exactly?...
	type = OFFIC_TYPE_NAVIGATOR;
	OfficerTypes.(type).skills.Leadership = 1;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 2;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 1;			// set from 0 to 1 by El Rapido
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;

	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("Turn180")) {OfficerTypes.(type).perks.Turn180 = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.(type).perks.SandbankManeuver = 1};
	if(isPerkExisting("SailingProfessional")) {OfficerTypes.(type).perks.SailingProfessional = 1};

	//Carpenter
	type = OFFIC_TYPE_CARPENTER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 2;
	OfficerTypes.(type).skills.Defence = 2;			// set from 1 to 2 by El Rapido
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;

	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.(type).perks.InstantRepair = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};    // added by El Rapido

	//Boatswain
	type = OFFIC_TYPE_BOATSWAIN;
	OfficerTypes.(type).skills.Leadership = 1;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 2;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;

	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("InstantBoarding")) {OfficerTypes.(type).perks.InstantBoarding = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.(type).perks.MusketsShoot = 1};

	/*
	// does not contribute anything - so no need to keep it as special role
	//Master at arms/abordage: this one is a little tricky as well...
	type = OFFIC_TYPECLASS_FIGHTER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	*/
}

int GetEffectiveSkill(ref character, string skillName)
{
	int skillPoints = GetCharacterSkill(character, skillName);
	return GetEffectiveSkillByValue(character, skillName, skillPoints);
}

int CalcEffectiveSkill(ref Character, string skillName)
{
	int skillPoints = CalcCharacterSkill(character, skillName);
	return GetEffectiveSkillByValue(character, skillName, skillPoints);
}

int GetEffectiveSkillByValue(ref character, string skillName, int skillPoints)
{
	// TODO: do we need to check main char or is it included in companions?
	// seems as if main char is companion 0...
	if(IsCompanion(character) || skillName == SKILL_FENCING)
	{
		return skillPoints;
	}

	if(CheckAttribute(character, "quest.officerType"))
	{
		int skillFactor;
		string officType = character.quest.officerType;
		if(CheckAttribute(OfficerTypes, officType))
			skillFactor = sti(OfficerTypes.(officType).skills.(skillName)); // KK
		else
			skillFactor = 2;
		// factor: can be 0, 1, 2:
		// 1: half contribution
		// 2: full contribution
		
		// calculate result = points * factor / 2
		// two variants: floor(result) or ceil(result)
		
		// this one corresponds to floor(result)
		// return skillPoints * skillFactor / 2;
		
		// this one corresponds to ceil(result)
		return (skillPoints * skillFactor + 1) / 2;
	}
	
	return 0;
}

void SetModifyValuesForRole(ref character, int primaryModify, int secondaryModify, int skillVariation, int fencing, int sneak)
{
	string officType = character.quest.officerType;
	int skillFactor = sti(OfficerTypes.(officType).skills.Leadership);
	int modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.LeadershipModify = modify;

	character.quest.FencingModify = fencing;

	skillFactor = sti(OfficerTypes.(officType).skills.Sailing);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.SailingModify = modify;

	skillFactor = sti(OfficerTypes.(officType).skills.Accuracy);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.AccuracyModify = modify;

	skillFactor = sti(OfficerTypes.(officType).skills.Cannons);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.CannonsModify = modify;

	skillFactor = sti(OfficerTypes.(officType).skills.Grappling);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.GrapplingModify = modify;

	skillFactor = sti(OfficerTypes.(officType).skills.Repair);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.RepairModify = modify;

	skillFactor = sti(OfficerTypes.(officType).skills.Defence);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.DefenceModify = modify;

	skillFactor = sti(OfficerTypes.(officType).skills.Commerce);
	modify = (skillFactor == 2) * primaryModify + (skillFactor == 1) * secondaryModify + (skillFactor == 0) * skillVariation;
	character.quest.CommerceModify = modify;

	character.quest.SneakModify = sneak;
}

// Aconcagua: return int:
// > 0: cost of selected perk
// < 0: could not assign perk
int selectPerkForOfficerType(ref character, string officerType, int freePoints)
{
	aref allPerks;
	aref chrPerks;
	makearef(allPerks, OfficerTypes.(officerType).perks);
	makearef(chrPerks, character.perks.list);

	int num = GetAttributesNum(allPerks);
        object assignablePerks;
	int n;
	string perk;
	for(n = 0; n < num; n++)
	{
		perk = GetAttributeName(GetAttributeN(allPerks, n));
		if(isPerkAssignable(character, perk, freePoints))
			assignablePerks.list.(perk) = 1;
	}

	makearef(allPerks, assignablePerks.list);
	num = GetAttributesNum(allPerks);
	if(num == 0)
		return -1;

	n = Rand(num - 1);
	perk = GetAttributeName(GetAttributeN(allPerks, n));
	character.perks.list.(perk) = 1;
	return GetPerkCost(perk);
}
